diff --git a/src/oldoffice_fmt_plug.c b/src/oldoffice_fmt_plug.c
index 0876240e92..f5398803d6 100644
--- a/src/oldoffice_fmt_plug.c
+++ b/src/oldoffice_fmt_plug.c
@@ -15,13 +15,16 @@ extern struct fmt_main fmt_oldoffice;
 john_register_one(&fmt_oldoffice);
 #else
 
+#include <string.h>
+#include <errno.h>
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "md5.h"
 #include "rc4.h"
-#include <string.h>
 #include "stdint.h"
-#include <assert.h>
 #include "sha.h"
-#include <errno.h>
 #include "arch.h"
 #include "misc.h"
 #include "common.h"
@@ -29,13 +32,12 @@ john_register_one(&fmt_oldoffice);
 #include "params.h"
 #include "options.h"
 #include "unicode.h"
-#ifdef _OPENMP
-#include <omp.h>
+#include "dyna_salt.h"
+#include "memdbg.h"
+
 #ifndef OMP_SCALE
 #define OMP_SCALE               256
 #endif
-#endif
-#include "memdbg.h"
 
 #define FORMAT_LABEL		"oldoffice"
 #define FORMAT_NAME		"MS Office <= 2003"
@@ -44,9 +46,9 @@ john_register_one(&fmt_oldoffice);
 #define BENCHMARK_LENGTH	-1000
 #define PLAINTEXT_LENGTH	64
 #define BINARY_SIZE		0
-#define SALT_SIZE		sizeof(struct custom_salt)
 #define BINARY_ALIGN	1
-#define SALT_ALIGN	sizeof(int)
+#define SALT_SIZE		sizeof(dyna_salt*)
+#define SALT_ALIGN		MEM_ALIGN_WORD
 
 #define MIN_KEYS_PER_CRYPT	1
 #define MAX_KEYS_PER_CRYPT	1
@@ -85,16 +87,18 @@ static int *saved_len;
 static int any_cracked, *cracked;
 static size_t cracked_size;
 
-static struct custom_salt {
+typedef struct {
+	dyna_salt dsalt;
 	int type;
 	unsigned char salt[16];
 	unsigned char verifier[16]; /* or encryptedVerifier */
 	unsigned char verifierHash[20];  /* or encryptedVerifierHash */
 	unsigned int has_mitm;
 	unsigned char mitm[5]; /* Meet-in-the-middle hint, if we have one */
-} *cur_salt;
+} custom_salt;
 
-static struct custom_salt cs;
+static custom_salt cs;
+static custom_salt *cur_salt = &cs;
 
 static void init(struct fmt_main *self)
 {
@@ -115,7 +119,6 @@ static void init(struct fmt_main *self)
 	any_cracked = 0;
 	cracked_size = sizeof(*cracked) * self->params.max_keys_per_crypt;
 	cracked = mem_calloc(1, cracked_size);
-	cur_salt = &cs;
 }
 
 static void done(void)
@@ -211,11 +214,16 @@ static void *get_salt(char *ciphertext)
 				+ atoi16[ARCH_INDEX(p[i * 2 + 1])];
 	} else
 		cs.has_mitm = 0;
+
 	MEM_FREE(keeptr);
-	return (void *)&cs;
+
+	cs.dsalt.salt_cmp_offset = SALT_CMP_OFF(custom_salt, type);
+	cs.dsalt.salt_cmp_size = SALT_CMP_SIZE(custom_salt, type, has_mitm, 0);
+	cs.dsalt.salt_alloc_needs_free = 0;
+
+	return mem_alloc_copy(&cs, sizeof(cs), MEM_ALIGN_WORD);
 }
 
-#if 0
 static char *source(char *source, void *binary)
 {
 	static char Buf[CIPHERTEXT_LENGTH];
@@ -261,11 +269,10 @@ static char *source(char *source, void *binary)
 	*cp = 0;
 	return Buf;
 }
-#endif
 
 static void set_salt(void *salt)
 {
-	cur_salt = (struct custom_salt *)salt;
+	cur_salt = (custom_salt *)salt;
 }
 
 static int crypt_all(int *pcount, struct db_salt *salt)
@@ -407,7 +414,7 @@ static char *get_key(int index)
 
 static unsigned int oo_hash_type(void *salt)
 {
-	struct custom_salt *my_salt;
+	custom_salt *my_salt;
 
 	my_salt = salt;
 	return (unsigned int) my_salt->type;
@@ -428,7 +435,7 @@ struct fmt_main fmt_oldoffice = {
 		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-		FMT_CASE | FMT_8_BIT | FMT_OMP | FMT_UNICODE | FMT_UTF8 | FMT_SPLIT_UNIFIES_CASE,
+		FMT_CASE | FMT_8_BIT | FMT_OMP | FMT_UNICODE | FMT_UTF8 | FMT_SPLIT_UNIFIES_CASE | FMT_DYNA_SALT,
 		{
 			"hash type",
 		},
@@ -445,11 +452,11 @@ struct fmt_main fmt_oldoffice = {
 		{
 			oo_hash_type,
 		},
-		fmt_default_source,
+		source,
 		{
 			fmt_default_binary_hash
 		},
-		fmt_default_salt_hash,
+		fmt_default_dyna_salt_hash,
 		NULL,
 		set_salt,
 		set_key,
diff --git a/src/opencl/oldoffice_kernel.cl b/src/opencl/oldoffice_kernel.cl
index 69ccf680a7..658b3bef53 100644
--- a/src/opencl/oldoffice_kernel.cl
+++ b/src/opencl/oldoffice_kernel.cl
@@ -19,6 +19,7 @@
 #include "opencl_sha1.h"
 
 typedef struct {
+	dyna_salt dsalt;
 	int type;
 	uint salt[16/4];
 	uint verifier[16/4]; /* or encryptedVerifier */
diff --git a/src/opencl_oldoffice_fmt_plug.c b/src/opencl_oldoffice_fmt_plug.c
index da76a02273..aa082f28be 100644
--- a/src/opencl_oldoffice_fmt_plug.c
+++ b/src/opencl_oldoffice_fmt_plug.c
@@ -29,6 +29,7 @@ john_register_one(&FORMAT_STRUCT);
 #include "params.h"
 #include "options.h"
 #include "unicode.h"
+#include "dyna_salt.h"
 
 #define FORMAT_LABEL		"oldoffice-opencl"
 #define FORMAT_NAME		"MS Office <= 2003"
@@ -38,8 +39,8 @@ john_register_one(&FORMAT_STRUCT);
 #define PLAINTEXT_LENGTH	19 //* 19 is leanest, 24, 28, 31, max. 51 */
 #define BINARY_SIZE		0
 #define BINARY_ALIGN		MEM_ALIGN_NONE
-#define SALT_SIZE		sizeof(struct custom_salt)
-#define SALT_ALIGN		sizeof(int)
+#define SALT_SIZE		sizeof(dyna_salt*)
+#define SALT_ALIGN		MEM_ALIGN_WORD
 #define MIN_KEYS_PER_CRYPT	1
 #define MAX_KEYS_PER_CRYPT	1
 
@@ -74,22 +75,24 @@ static struct fmt_tests oo_tests[] = {
 
 extern volatile int bench_running;
 
-static struct custom_salt {
+typedef struct {
+	dyna_salt dsalt;
 	int type;
 	unsigned char salt[16];
 	unsigned char verifier[16]; /* or encryptedVerifier */
 	unsigned char verifierHash[20];  /* or encryptedVerifierHash */
 	unsigned int has_mitm;
 	unsigned char mitm[8]; /* Meet-in-the-middle hint, if we have one */
-} *cur_salt;
+} custom_salt;
+
+static custom_salt cs;
+static custom_salt *cur_salt = &cs;
 
 typedef struct {
 	uint len;
 	ushort password[PLAINTEXT_LENGTH + 1];
 } mid_t;
 
-static struct custom_salt cs;
-
 static char *saved_key;
 static int any_cracked;
 static int new_keys;
@@ -342,10 +345,13 @@ static void *get_salt(char *ciphertext)
 		cs.has_mitm = 0;
 	MEM_FREE(keeptr);
 
-	return (void *)&cs;
+	cs.dsalt.salt_cmp_offset = SALT_CMP_OFF(custom_salt, type);
+	cs.dsalt.salt_cmp_size = SALT_CMP_SIZE(custom_salt, type, has_mitm, 0);
+	cs.dsalt.salt_alloc_needs_free = 0;
+
+	return mem_alloc_copy(&cs, sizeof(cs), MEM_ALIGN_WORD);
 }
 
-#if 0
 static char *source(char *source, void *binary)
 {
 	static char Buf[CIPHERTEXT_LENGTH];
@@ -391,11 +397,10 @@ static char *source(char *source, void *binary)
 	*cp = 0;
 	return Buf;
 }
-#endif
 
 static void set_salt(void *salt)
 {
-	cur_salt = (struct custom_salt *)salt;
+	cur_salt = (custom_salt *)salt;
 	HANDLE_CLERROR(clEnqueueWriteBuffer(queue[gpu_id], cl_benchmark, CL_FALSE, 0, sizeof(bench_running), (void*)&bench_running, 0, NULL, NULL), "Failed transferring salt");
 	HANDLE_CLERROR(clEnqueueWriteBuffer(queue[gpu_id], cl_salt, CL_FALSE, 0, SALT_SIZE, cur_salt, 0, NULL, NULL), "Failed transferring salt");
 }
@@ -511,7 +516,7 @@ static char *get_key(int index)
 
 static unsigned int oo_hash_type(void *salt)
 {
-	struct custom_salt *my_salt;
+	custom_salt *my_salt;
 
 	my_salt = salt;
 	return (unsigned int) my_salt->type;
@@ -532,7 +537,7 @@ struct fmt_main FORMAT_STRUCT = {
 		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-		FMT_CASE | FMT_8_BIT | FMT_UNICODE | FMT_UTF8 | FMT_SPLIT_UNIFIES_CASE,
+		FMT_CASE | FMT_8_BIT | FMT_UNICODE | FMT_UTF8 | FMT_SPLIT_UNIFIES_CASE | FMT_DYNA_SALT,
 		{
 			"hash type",
 		},
@@ -549,11 +554,11 @@ struct fmt_main FORMAT_STRUCT = {
 		{
 			oo_hash_type,
 		},
-		fmt_default_source,
+		source,
 		{
 			fmt_default_binary_hash
 		},
-		fmt_default_salt_hash,
+		fmt_default_dyna_salt_hash,
 		NULL,
 		set_salt,
 		set_key,
